import '../renderer/stage.dart';
import '../extensions/extensions.dart';

abstract class BaseInfo<T> {
  final T raw;
  BaseInfo(this.raw);
}

abstract class PositionInfo<T> extends BaseInfo<T> {
  final Vector2 position;

  PositionInfo(Stage stage, Offset globalPosition, T raw)
      : position = stage.convertGlobalToLocalCoordinate(globalPosition.toVector2()),
        super(raw);
}

mixin HandledField {
  bool handled = false;
}
