import 'package:flutter/gestures.dart';

import '../extensions/extensions.dart';
import '../renderer/stage.dart';
import 'events.dart';

mixin ScrollDetectorMixin on Stage {
  void onScroll(PointerScrollInfo info) {}
}

class PointerScrollInfo extends PositionInfo<PointerScrollEvent> {
  final Vector2 delta;

  PointerScrollInfo.fromDetails(Stage stage, PointerScrollEvent raw)
      : delta = raw.scrollDelta.toVector2(),
        super(stage, raw.position, raw);
}
