import 'package:flutter/gestures.dart';

import '../renderer/stage.dart';
import 'events.dart';

mixin TapDetectorMixin on Stage {
  void onTap() {}
  void onTapCancel() {}
  void onTapDown(TapDownInfo info) {}
  void onTapUp(TapUpInfo info) {}
}

mixin DoubleTapDetectorMixin on Stage {
  void onDoubleTap() {}
  void onDoubleTapCancel() {}
  void onDoubleTapDown(TapDownInfo info) {}
}

class TapDownInfo extends PositionInfo<TapDownDetails> with HandledField {
  TapDownInfo.fromDetails(
    Stage stage,
    TapDownDetails raw,
  ) : super(stage, raw.globalPosition, raw);
}

class TapUpInfo extends PositionInfo<TapUpDetails> with HandledField {
  TapUpInfo.fromDetails(
    Stage stage,
    TapUpDetails raw,
  ) : super(stage, raw.globalPosition, raw);
}
