import 'package:flutter/material.dart';
import 'package:vector_math/vector_math_64.dart';

import '../renderer/stage.dart';

class ResizeWidget extends StatefulWidget {
  final Stage stage;
  final Vector2 canvasSize;

  const ResizeWidget({
    Key? key,
    required this.stage,
    required this.canvasSize,
  }) : super(key: key);

  @override
  _ResizeWidgetState createState() => _ResizeWidgetState();
}

class _ResizeWidgetState extends State<ResizeWidget> {
  @override
  void initState() {
    super.initState();
    widget.stage.onCanvasResize(widget.canvasSize);
  }

  @override
  void didUpdateWidget(ResizeWidget oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (oldWidget.canvasSize != widget.canvasSize) {
      widget.stage.onCanvasResize(widget.canvasSize);
    }
  }

  @override
  Widget build(BuildContext context) {
    return const SizedBox.shrink();
  }
}
